﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public abstract class CodeNode : Symbol {
    public abstract string Prefix { get; set; }
    public abstract string Suffix { get; set; }

    [StorableConstructor]
    protected CodeNode(bool deserializing) : base(deserializing) { }
    protected CodeNode(CodeNode original, Cloner cloner)
      : base(original, cloner) {
      this.Prefix = original.Prefix;
      this.Suffix = original.Suffix;
    }
    protected CodeNode(string name, string description)
      : base(name, description) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      throw new System.NotImplementedException();
    }

    public override int MaximumArity {
      get { throw new System.NotImplementedException(); }
    }

    public override int MinimumArity {
      get { throw new System.NotImplementedException(); }
    }

    public abstract string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children);
  }
}
